import random

import pytest

import unit_converter as rust
import py_unit_converter as py


@pytest.fixture(scope="module")
def batch_numbers():
    return [random.random() * 100 for x in range(1000)]
    # The larger the range of numbers, the closer the Rust version is to Python.
    # e.g. return [random.random() * 100 for x in range(1000000)]


def test_using_python_batch(benchmark, batch_numbers):
    benchmark(py.batch_converter, batch_numbers)


def test_using_rust_batch(benchmark, batch_numbers):
    benchmark(rust.batch_converter, batch_numbers)
