import random

import unit_converter as rust
import py_unit_converter as py


def test_using_unit_converter():
    rusty = rust.Temperature(25.0)
    snakey = py.Temperature(25.0)
    assert rusty.to_fahrenheit() == 77.0
    assert snakey.to_fahrenheit() == 77.0


def test_using_python_constant(benchmark):
    result = benchmark(python_unit_converter, 25.0)
    assert round(result, 3) == round(77.0, 3)


def test_using_rust_constant(benchmark):
    result = benchmark(unit_converter.convert_to_fahrenheit, 25.0)
    assert round(result, 3) == round(77.0, 3)


def test_using_python(benchmark):
    temperature = random.random() * 100
    result = benchmark(python_unit_converter, temperature)
    assert round(result, 3) == round(python_unit_converter(temperature), 3)


def test_using_rust(benchmark):
    temperature = random.random() * 100
    result = benchmark(unit_converter.convert_to_fahrenheit, temperature)
    assert round(result, 3) == round(python_unit_converter(temperature), 3)
